SystemOrganization addCategory: #'Keymapping-Shortcuts'!

!ByteString methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 23:17'!
asShortcut
	self size > 1 
		ifTrue: [ self error: 'Shortcuts only take a single letter'].
	^ KMSingleKeyShortcut from: self first! !

!Character methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 23:13'!
alt
	^ KMModifier alt + self! !

!Character methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 23:16'!
asShortcut
	^ KMSingleKeyShortcut from: self! !

!Character methodsFor: '*Keymapping-Shortcuts' stamp: 'GuillermoPolito 5/31/2011 18:25'!
command
	^ KMModifier command + self! !

!Character methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 22:57'!
ctrl
	^ KMModifier ctrl + self! !

!Character methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 22:57'!
shift
	^ KMModifier shift + self! !

!Integer methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 23:14'!
alt
	^ KMModifier alt + self! !

!Integer methodsFor: '*Keymapping-Shortcuts' stamp: 'GuillermoPolito 5/31/2011 18:26'!
command
	^ KMModifier command + self! !

!Integer methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 23:14'!
ctrl
	^ KMModifier ctrl + self! !

!Integer methodsFor: '*Keymapping-Shortcuts' stamp: 'CamilloBruni 3/18/2011 23:14'!
shift
	^ KMModifier shift + self! !

!Collection methodsFor: '*keymapping-shortcuts' stamp: 'GuillermoPolito 11/2/2011 22:33'!
asShortcut
	| shortcut |
	self size = 1 ifTrue: [ ^self first asShortcut ].

	shortcut := KMChainedShortcut new.
	self do: [ :each | shortcut addShortcut: each asShortcut ].
	^shortcut.! !

Object subclass: #KMCombinationShortcut
	instanceVariableNames: 'shortcuts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMCombinationShortcut class methodsFor: 'instance creation' stamp: 'GuillermoPolito 9/24/2012 11:38'!
withShortcuts: someShortcuts
	^self new
			shortcuts: someShortcuts;
			yourself! !

!KMCombinationShortcut methodsFor: 'combining' stamp: 'GuillermoPolito 9/24/2012 11:42'!
collect: aBlock
	^shortcuts collect: aBlock! !

!KMCombinationShortcut methodsFor: 'combining' stamp: 'GuillermoPolito 9/24/2012 11:41'!
combinationsDo: aBlock
	^shortcuts do: aBlock! !

!KMCombinationShortcut methodsFor: 'combining' stamp: 'GuillermoPolito 9/24/2012 11:40'!
includes: aShortcut
	^shortcuts includes: aShortcut! !

!KMCombinationShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 9/24/2012 11:37'!
shortcuts: someShortcuts
	shortcuts := someShortcuts! !

!KMCombinationShortcut methodsFor: 'combining' stamp: 'GuillermoPolito 9/24/2012 11:39'!
| aShortcut
	^KMCombinationShortcut withShortcuts: (shortcuts copyWith: aShortcut)! !

Object subclass: #KMPlatformSpecificShortcut
	instanceVariableNames: 'shortcut platform'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMPlatformSpecificShortcut class methodsFor: 'instance creation' stamp: 'GuillermoPolito 9/24/2012 11:14'!
with: aShortcut onPlatform: aPlatform
	^self new
			shortcut: aShortcut;
			platform: aPlatform;
			yourself! !

!KMPlatformSpecificShortcut methodsFor: 'combining' stamp: 'GuillermoPolito 9/24/2012 11:40'!
combinationsDo: aBlock
	aBlock value: self! !

!KMPlatformSpecificShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 9/24/2012 11:15'!
platform
	^platform! !

!KMPlatformSpecificShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 9/24/2012 11:14'!
platform: aPlatform
	platform := aPlatform! !

!KMPlatformSpecificShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 9/24/2012 11:14'!
shortcut
	^shortcut! !

!KMPlatformSpecificShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 9/24/2012 11:13'!
shortcut: aShortcut
	shortcut := aShortcut! !

!KMPlatformSpecificShortcut methodsFor: 'combining' stamp: 'GuillermoPolito 9/24/2012 11:38'!
| aShortcut
	^KMCombinationShortcut withShortcuts: { self . aShortcut }! !

Object subclass: #KMShortcut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

KMShortcut subclass: #KMChainedShortcut
	instanceVariableNames: 'shortcuts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMChainedShortcut class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
first: aShortcut next: anotherShortcut
	^ (self new)
		first: aShortcut;
		next: anotherShortcut;
		yourself! !

!KMChainedShortcut methodsFor: 'building' stamp: 'GuillermoPolito 3/15/2011 00:33'!
+ aCharacter 
	| last |
	last := self shortcuts last.
	self shortcuts removeLast.
	self addShortcut: last + aCharacter.! !

!KMChainedShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/19/2011 20:26'!
, aShortcut
	self addShortcut: aShortcut asShortcut.! !

!KMChainedShortcut methodsFor: 'comparing' stamp: 'CamilloBruni 3/18/2011 23:11'!
= aShortcut
	^ super = aShortcut and: [ shortcuts = aShortcut shortcuts ]! !

!KMChainedShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 12/24/2010 22:40'!
addShortcut: aShortcut
	self shortcuts add: aShortcut! !

!KMChainedShortcut methodsFor: 'building' stamp: 'GuillermoPolito 9/12/2011 16:42'!
asShortcut
	^self! !

!KMChainedShortcut methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/3/2012 15:57'!
beginsWith: aShortcut 
	
	^ self shortcuts first = aShortcut ! !

!KMChainedShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 12/24/2010 22:39'!
first: aShortcut
	self addShortcut: aShortcut! !

!KMChainedShortcut methodsFor: 'comparing' stamp: 'CamilloBruni 3/18/2011 23:11'!
hash
	^ shortcuts hash! !

!KMChainedShortcut methodsFor: 'comparing' stamp: 'GuillermoPolito 11/2/2011 22:33'!
matches: anEventBuffer
	|maxIndex|
	maxIndex := anEventBuffer size min: shortcuts size.
	1 to: maxIndex do: [:index|
		((shortcuts at: index) = (anEventBuffer at: index) asShortcut)
			ifFalse: [ ^ false]].
	^ true.! !

!KMChainedShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 3/15/2011 00:42'!
next: aShortcut
	self addShortcut: aShortcut! !

!KMChainedShortcut methodsFor: 'printing' stamp: 'CamilloBruni 3/20/2011 23:44'!
printOn: aStream
	shortcuts 
		do: [ :shortcut| shortcut printOn: aStream]
		separatedBy: [ aStream nextPutAll: ' , '].! !

!KMChainedShortcut methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
shortcuts
	^ shortcuts ifNil: [ shortcuts := OrderedCollection new ]! !

KMShortcut subclass: #KMModifiedShortcut
	instanceVariableNames: 'modifier character'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMModifiedShortcut class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
modifier: aModifier character: aCharacter
	^ (self new)
		modifier: aModifier;
		character: aCharacter;
		yourself! !

!KMModifiedShortcut methodsFor: 'comparing' stamp: 'GuillermoPolito 10/20/2011 16:30'!
= aShortcut
	super = aShortcut
		ifFalse: [ ^ false ]. 
	aShortcut modifier = modifier 
		ifFalse: [ ^ false ].
	aShortcut character = character
		ifFalse: [ ^ false ].
	^ true! !

!KMModifiedShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/19/2011 21:19'!
alt
	^ self modifiedBy: KMModifier alt! !

!KMModifiedShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
asShortcut
	^ self! !

!KMModifiedShortcut methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/3/2012 15:59'!
beginsWith: aKMShortcut 

	^ self = aKMShortcut ! !

!KMModifiedShortcut methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
character
	^ character! !

!KMModifiedShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 12/25/2010 14:22'!
character: aCharacter 
	character := aCharacter.! !

!KMModifiedShortcut methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 18:26'!
command
	^ self modifiedBy: KMModifier command! !

!KMModifiedShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
ctrl
	^ self modifiedBy: KMModifier ctrl! !

!KMModifiedShortcut methodsFor: 'comparing' stamp: 'CamilloBruni 3/18/2011 23:11'!
hash
	^ character hash + modifier hash! !

!KMModifiedShortcut methodsFor: 'accessing' stamp: 'SeanDeNigris 11/22/2011 18:39'!
key

	^ self character key.! !

!KMModifiedShortcut methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/20/2011 15:51'!
matchesEvent: aKeyboardEvent
	^ (self modifier matchesEvent: aKeyboardEvent) 
		and: [self character matchesEvent: aKeyboardEvent]! !

!KMModifiedShortcut methodsFor: 'printing' stamp: 'GuillermoPolito 4/9/2011 23:57'!
modifiedBy: aModifier
	modifier := modifier + aModifier.! !

!KMModifiedShortcut methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
modifier
	^ modifier! !

!KMModifiedShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 12/24/2010 22:31'!
modifier: aModifier
	modifier := aModifier! !

!KMModifiedShortcut methodsFor: 'printing' stamp: 'CamilloBruni 3/20/2011 23:45'!
printOn: aStream
	modifier printOn: aStream.
	aStream << ' + '.
	character printOn: aStream.! !

!KMModifiedShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
shift
	^ self modifiedBy: KMModifier shift! !

KMShortcut subclass: #KMModifier
	instanceVariableNames: 'identifier name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

KMModifier subclass: #KMAltModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMAltModifier methodsFor: 'initialization' stamp: 'CamilloBruni 3/20/2011 23:54'!
initialize
	super initialize.
	identifier := #a.
	name := 'Alt'.! !

!KMAltModifier methodsFor: 'matching' stamp: 'CamilloBruni 3/19/2011 20:50'!
matchesEvent: aKeyboardEvent
	^ aKeyboardEvent altKeyPressed! !

KMModifier subclass: #KMCommandModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMCommandModifier methodsFor: 'accessing' stamp: 'SeanDeNigris 11/22/2011 18:53'!
eventCode

	^ 64.! !

!KMCommandModifier methodsFor: 'initialization' stamp: 'GuillermoPolito 5/31/2011 19:54'!
initialize
	super initialize.
	identifier := #m.
	name := 'Cmd'.! !

!KMCommandModifier methodsFor: 'matching' stamp: 'EstebanLorenzano 3/6/2013 16:41'!
matchesEvent: aKeyboardEvent
	self flag: #todo. "Command in windows and linux platforms is 'meta' key and do not have any sense (for the 
	 environment, right now). In the future we need to create a KMMetaModifier to handle properly this, and 
	 keep command as a mac-specific key"
	(OSPlatform isUnix or: [ OSPlatform isWin32 ])
		ifTrue: [ ^ aKeyboardEvent controlKeyPressed ].		 

	^ aKeyboardEvent commandKeyPressed! !

KMModifier subclass: #KMComposedModifier
	instanceVariableNames: 'modifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMComposedModifier methodsFor: 'arithmetic' stamp: 'GuillermoPolito 4/10/2011 02:32'!
+ modified
	^ modified asShortcut modifiedBy: self! !

!KMComposedModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/19/2011 21:22'!
= aShortcut
	(aShortcut isKindOf: self class)
		ifFalse: [^ false].
	^ aShortcut modifiers = modifiers! !

!KMComposedModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/19/2011 21:20'!
alt
	modifiers add: KMModifier alt! !

!KMComposedModifier methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 18:26'!
command
	modifiers add: KMModifier command! !

!KMComposedModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/19/2011 21:21'!
ctrl
	modifiers add: KMModifier ctrl! !

!KMComposedModifier methodsFor: 'comparing' stamp: 'GuillermoPolito 5/1/2012 12:26'!
hash
	^ modifiers hash! !

!KMComposedModifier methodsFor: 'initialization' stamp: 'CamilloBruni 3/19/2011 21:17'!
initialize
	super initialize.
	modifiers := Set new.! !

!KMComposedModifier methodsFor: 'matching' stamp: 'CamilloBruni 3/19/2011 21:18'!
matchesEvent: aKeyboardEvent
	^ modifiers allSatisfy: [:modifier|
		modifier matchesEvent: aKeyboardEvent]! !

!KMComposedModifier methodsFor: 'printing' stamp: 'CamilloBruni 3/20/2011 23:57'!
modifiedBy: modifier
	modifiers add: modifier.
	self updateIdentifier.! !

!KMComposedModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/19/2011 21:23'!
modifiers
	^ modifiers! !

!KMComposedModifier methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 23:47'!
printOn: aStream
	modifiers
		do: [ :modifier| modifier printOn: aStream ]
		separatedBy: [ aStream << ' + ' ].! !

!KMComposedModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/19/2011 21:21'!
shift
	modifiers add: KMModifier shift! !

!KMComposedModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/20/2011 23:59'!
updateIdentifier
	identifier := String streamContents: [ :aStream|
			modifiers do: [ :modifier| 
				aStream << modifier identifier]].
	identifier := identifier asSymbol! !

KMModifier subclass: #KMCtrlModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMCtrlModifier methodsFor: 'initialization' stamp: 'GuillermoPolito 4/9/2011 23:52'!
initialize
	super initialize.
	identifier := #c.
	name := 'Ctrl'.! !

!KMCtrlModifier methodsFor: 'matching' stamp: 'CamilloBruni 3/19/2011 20:50'!
matchesEvent: aKeyboardEvent
	^ aKeyboardEvent controlKeyPressed! !

!KMModifier class methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
alt
	^ KMAltModifier new! !

!KMModifier class methodsFor: 'building' stamp: 'GuillermoPolito 5/31/2011 18:25'!
command
	^ KMCommandModifier new! !

!KMModifier class methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
ctrl
	^ KMCtrlModifier new! !

!KMModifier class methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
shift
	^ KMShiftModifier new! !

!KMModifier methodsFor: 'arithmetic' stamp: 'CamilloBruni 3/19/2011 21:25'!
+ modifier
	^ modifier asShortcut modifiedBy: self! !

!KMModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/20/2011 23:58'!
= aShortcut
	super = aShortcut
		ifFalse: [ ^ false ]. 
	aShortcut identifier = identifier 
		ifFalse: [ ^ false ].
	^ true! !

!KMModifier methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
asShortcut
	^ self! !

!KMModifier methodsFor: 'accessing' stamp: 'SeanDeNigris 11/22/2011 19:00'!
eventCode
	"No modifiers"
	
	^ 0.! !

!KMModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/20/2011 23:54'!
hash
	^ identifier hash bitXor: name hash! !

!KMModifier methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 23:54'!
identifier
	^ identifier! !

!KMModifier methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 23:54'!
kmString
	^ identifier! !

!KMModifier methodsFor: 'comparing' stamp: 'CamilloBruni 3/19/2011 20:49'!
matches: aKeyboardEvent
	self shouldNotImplement! !

!KMModifier methodsFor: 'matching' stamp: 'CamilloBruni 3/19/2011 20:50'!
matchesEvent: aKeyboardEvent
	self subclassResponsibility! !

!KMModifier methodsFor: 'printing' stamp: 'CamilloBruni 3/19/2011 21:16'!
modifiedBy: modifier
	^ KMComposedModifier new
		modifiedBy: modifier;
		modifiedBy: self;
		yourself! !

!KMModifier methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 23:54'!
name
	^ name! !

!KMModifier methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 23:54'!
printOn: aStream
	aStream << name! !

KMModifier subclass: #KMShiftModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMShiftModifier methodsFor: 'initialization' stamp: 'CamilloBruni 3/20/2011 23:55'!
initialize
	super initialize.
	identifier := #s.
	name := 'Shift'.! !

!KMShiftModifier methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 15:50'!
matchesEvent: aKeyboardEvent
	^ aKeyboardEvent shiftPressed! !

KMShortcut subclass: #KMNoShortcut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

!KMNoShortcut commentStamp: 'CamilloBruni 3/21/2011 00:05' prior: 0!
I do not respond to any keyboard event. Mostly used in the settings to deactivate a certain command.!

!KMNoShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
+ aKMModifier
	^ aKMModifier! !

!KMNoShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
, aShortcut
	^ aShortcut! !

!KMNoShortcut methodsFor: 'matching' stamp: 'CamilloBruni 3/20/2011 23:50'!
matches: anEventBuffer
	^ false! !

!KMNoShortcut methodsFor: 'matching' stamp: 'CamilloBruni 3/20/2011 23:50'!
matchesCompletely: anEventBuffer
	^ false! !

!KMNoShortcut methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 23:41'!
printOn: aStream! !

!KMShortcut class methodsFor: 'building' stamp: 'DeboraFortini 12/13/2011 14:25'!
fromKeyboardEvent: evt
	| modifier control command shift hasModifier keyString |
	control := evt controlKeyPressed.
	command := evt commandKeyPressed.
	shift := evt shiftPressed.
	(shift | command | control)
		ifFalse: [^ KMSingleKeyShortcut from: evt keyCharacter ].
	modifier := KMNoShortcut new.
	control
		ifTrue: [ modifier := modifier + KMModifier ctrl ].
	command
		ifTrue: [ modifier := modifier + KMModifier command ].
	shift
		ifTrue: [ modifier := modifier + KMModifier shift ].
	^ modifier + evt modifiedCharacter! !

!KMShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
, aShortcut
	^ KMChainedShortcut first: self next: aShortcut asShortcut! !

!KMShortcut methodsFor: 'comparing' stamp: 'CamilloBruni 3/18/2011 23:11'!
= aShortcut
	^ aShortcut isKindOf: self species! !

!KMShortcut methodsFor: 'converting' stamp: 'GuillermoPolito 11/2/2011 22:33'!
asShortcut
	^self! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 11:40'!
combinationsDo: aBlock
	aBlock value: self! !

!KMShortcut methodsFor: 'comparing' stamp: 'CamilloBruni 3/18/2011 23:11'!
hash
	^ self species hash! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 11:04'!
includes: aShortcut
	^self = aShortcut! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 11:23'!
mac
	^KMPlatformSpecificShortcut with: self onPlatform: #MacOSX! !

!KMShortcut methodsFor: 'comparing' stamp: 'GuillermoPolito 10/20/2011 16:42'!
matches: anEventBuffer
	^ self matchesCompletely: anEventBuffer first! !

!KMShortcut methodsFor: 'comparing' stamp: 'GuillermoPolito 11/2/2011 22:30'!
matchesCompletely: aKeyboardEvent
	^self = aKeyboardEvent asShortcut! !

!KMShortcut methodsFor: 'building' stamp: 'GuillermoPolito 4/6/2012 13:26'!
named: keymapName do: anActionBlock
	^ KMKeymap
		named: keymapName
		shortcut: self
		action: anActionBlock! !

!KMShortcut methodsFor: 'building' stamp: 'GuillermoPolito 4/6/2012 13:49'!
named: keymapName do: anActionBlock withDescription: aDescription
	^ KMKeymap
		named: keymapName
		shortcut: self
		action: anActionBlock
		description: aDescription! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 11:10'!
platform
	^#all! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 10:59'!
shortcut
	^self! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 11:23'!
unix
	^KMPlatformSpecificShortcut with: self onPlatform: #Unix! !

!KMShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
value: aBuilder
	^ self! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 11:15'!
win
	^KMPlatformSpecificShortcut with: self onPlatform: #Windows! !

!KMShortcut methodsFor: 'combination' stamp: 'GuillermoPolito 9/24/2012 11:38'!
| aShortcut
	^KMCombinationShortcut withShortcuts: { self . aShortcut }! !

KMShortcut subclass: #KMSingleKeyShortcut
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Shortcuts'!

KMSingleKeyShortcut class
	instanceVariableNames: 'specialKeys'!

KMSingleKeyShortcut class
	instanceVariableNames: 'specialKeys'!

!KMSingleKeyShortcut class methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:25'!
from: aString
	^ (self new)
		key: aString asCharacter;
		yourself! !

!KMSingleKeyShortcut class methodsFor: 'building' stamp: 'GuillermoPolito 10/21/2011 09:33'!
specialKeys
	^specialKeys
		ifNil: [ specialKeys :=
				{1->'home'.
				3->'enter'.
				4->'end'.
				8->'backspace'.
				9-> 'tab'.
				11->'page up'.
				12->'page down'.
				27->'escape'.
				28->'left arrow'.
				29->'right arrow'.
				30->'up arrow'.
				31->'down arrow'.
				127->'delete'
				} asDictionary.]! !

!KMSingleKeyShortcut methodsFor: 'comparing' stamp: 'GuillermoPolito 10/20/2011 16:30'!
= aShortcut
	^ super = aShortcut and: [ aShortcut key sameAs: key ]! !

!KMSingleKeyShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/18/2011 23:11'!
asShortcut
	^ self! !

!KMSingleKeyShortcut methodsFor: 'comparing' stamp: 'CamilloBruni 3/18/2011 23:11'!
hash
	^ key hash! !

!KMSingleKeyShortcut methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
key
	^ key! !

!KMSingleKeyShortcut methodsFor: 'accessing' stamp: 'GuillermoPolito 12/25/2010 14:21'!
key: aKeyString
	key := aKeyString.! !

!KMSingleKeyShortcut methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 10/18/2011 19:40'!
matchesEvent: aKeyboardEvent
	^ self key asLowercase = aKeyboardEvent modifiedCharacter asLowercase! !

!KMSingleKeyShortcut methodsFor: 'building' stamp: 'CamilloBruni 3/19/2011 21:13'!
modifiedBy: aModifier
	^ KMModifiedShortcut modifier: aModifier character: self! !

!KMSingleKeyShortcut methodsFor: 'accessing' stamp: 'SeanDeNigris 11/22/2011 18:59'!
modifier

	^ KMModifier new.! !

!KMSingleKeyShortcut methodsFor: 'showing' stamp: 'GuillermoPolito 4/10/2011 02:37'!
printOn: aStream
	aStream nextPutAll: (self printStringFor: key) asString asUppercase.! !

!KMSingleKeyShortcut methodsFor: 'showing' stamp: 'GuillermoPolito 4/10/2011 02:17'!
printStringFor: aCharacter
	| specialKeys |
	specialKeys := self specialKeys.
	
	^specialKeys at: aCharacter asciiValue ifAbsent: [ aCharacter ].! !

!KMSingleKeyShortcut methodsFor: 'showing' stamp: 'GuillermoPolito 4/10/2011 02:18'!
specialKeys
	 ^self class specialKeys! !
